diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/hwmp-protocol.h ns-3.34/src/mesh/model/dot11s/hwmp-protocol.h
--- ns-3.33/src/mesh/model/dot11s/hwmp-protocol.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/hwmp-protocol.h	2021-07-14 10:31:07.000000000 -0700
@@ -70,6 +70,7 @@
   HwmpProtocol ();
   ~HwmpProtocol ();
   void DoDispose ();
+
   /**
    * \brief structure of unreachable destination - address and sequence number
    */
@@ -79,7 +80,6 @@
     uint32_t seqnum; ///< sequence number
   };
 
-  typedef struct FailedDestination FailedDestination;
   /**
    * Route request, inherited from MeshL2RoutingProtocol
    *
@@ -107,6 +107,7 @@
                            const Mac48Address destination, Ptr<Packet>  packet, uint16_t&  protocolType);
   /**
    * \brief Install HWMP on given mesh point.
+   * \param mp the MeshPointDevice
    * \returns true if successful
    *
    * Installing protocol causes installation of its interface MAC plugins.
@@ -114,7 +115,7 @@
    * Also MP aggregates all installed protocols, HWMP protocol can be accessed
    * via MeshPointDevice::GetObject<dot11s::HwmpProtocol>();
    */
-  bool Install (Ptr<MeshPointDevice>);
+  bool Install (Ptr<MeshPointDevice> mp);
   /**
    * Peer link status function
    * \param meshPontAddress The MAC address of the mesh point
@@ -128,15 +129,25 @@
    * \param cb is a callback, which returns a list of addresses on given interface (uint32_t)
    */
   void SetNeighboursCallback (Callback<std::vector<Mac48Address>, uint32_t> cb);
-  ///\name Proactive PREQ mechanism:
-  ///\{
+  /// \name Proactive PREQ mechanism:
+  ///@{
+  /// Set the current node as root
   void SetRoot ();
+  /// Unset the current node as root
   void UnsetRoot ();
-  ///\}
-  ///\brief Statistics:
-  void Report (std::ostream &) const;
+  ///@}
+
+  /// \brief Statistics:
+  ///@{
+  /**
+   *  Print statistics counters
+   *  \param os the output stream
+   */
+  void Report (std::ostream & os) const;
   ///\brief Reset Statistics:
   void ResetStats ();
+  ///@}
+
   /**
    * Assign a fixed random variable stream number to the random variables
    * used by this model.  Return the number of streams (possibly zero) that
@@ -166,10 +177,10 @@
    */
   HwmpProtocol& operator= (const HwmpProtocol & hwmp);
   /**
-   * type conversion
-   * \returns the HWMP protocol
+   * Copy constructor - defined but not implemented (on purpose)
+   * \param hwmp the HWMP protocol
    */
-  HwmpProtocol (const HwmpProtocol &);
+  HwmpProtocol (const HwmpProtocol & hwmp);
 
   /**
    * \brief Structure of path error: IePerr and list of receivers:
@@ -208,8 +219,8 @@
   bool ForwardUnicast (uint32_t sourceIface, const Mac48Address source, const Mac48Address destination,
                        Ptr<Packet> packet, uint16_t protocolType, RouteReplyCallback routeReply, uint32_t ttl);
 
-  ///\name Interaction with HWMP MAC plugin
-  //\{
+  /// \name Interaction with HWMP MAC plugin
+  ///@{
   /**
    * \brief Handler for receiving Path Request
    *
@@ -307,23 +318,47 @@
    * \param source is the source address
    */
   bool DropDataFrame (uint32_t seqno, Mac48Address source);
-  //\}
+  ///@}
+
   /// Route discovery time:
   TracedCallback<Time> m_routeDiscoveryTimeCallback;
   /// RouteChangeTracedCallback typedef
   typedef TracedCallback <struct RouteChange> RouteChangeTracedCallback;
   /// Route change trace source
   TracedCallback<struct RouteChange> m_routeChangeTraceSource;
-  ///\name Methods related to Queue/Dequeue procedures
-  ///\{
+
+  // /\name Methods related to Queue/Dequeue procedures
+  ///@{
+  /**
+   * Queue a packet
+   * \param packet the packet to be queued
+   * \return true on success
+   */
   bool QueuePacket (QueuedPacket packet);
+  /**
+   * Dequeue the first packet for a given destination
+   * \param dst the destination
+   * \return the dequeued packet
+   */
   QueuedPacket  DequeueFirstPacketByDst (Mac48Address dst);
+  /**
+   * Dequeue the first packet in the queue
+   * \return the dequeued packet
+   */
   QueuedPacket  DequeueFirstPacket ();
+  /**
+   * Signal the protocol that the reactive path toward a destination is now available
+   * \param dst the destination
+   */
   void ReactivePathResolved (Mac48Address dst);
+  /**
+   * Signal the protocol that the proactive path is now available
+   */
   void ProactivePathResolved ();
-  ///\}
-  ///\name Methods responsible for path discovery retry procedure:
-  ///\{
+  ///@}
+
+  /// \name Methods responsible for path discovery retry procedure:
+  ///@{
   /**
    * \brief checks when the last path discovery procedure was started for a given destination.
    * \return true if should send PREQ
@@ -343,10 +378,12 @@
   void  RetryPathDiscovery (Mac48Address dst, uint8_t numOfRetry);
   /// Proactive Preq routines:
   void SendProactivePreq ();
-  ///\}
+  ///@}
+
   ///\return address of MeshPointDevice
   Mac48Address GetAddress ();
-  ///\name Methods needed by HwmpMacLugin to access protocol parameters:
+  /// \name Methods needed by HwmpMacLugin to access protocol parameters:
+  ///@{
   /**
    * Get do flag function
    * \returns DO flag
@@ -392,6 +429,8 @@
    * \returns the unicast PERR threshold
    */
   uint8_t GetUnicastPerrThreshold ();
+  ///@}
+
 private:
   /// Statistics structure
   struct Statistics
@@ -421,13 +460,13 @@
   uint32_t m_dataSeqno; ///< data sequence no
   uint32_t m_hwmpSeqno; ///< HWMP sequence no
   uint32_t m_preqId; ///< PREQ ID
-  ///\name Sequence number filters
-  ///\{
+  /// \name Sequence number filters
+  ///@{
   /// Data sequence number database
   std::map<Mac48Address, uint32_t> m_lastDataSeqno;
   /// keeps HWMP seqno (first in pair) and HWMP metric (second in pair) for each address
   std::map<Mac48Address, std::pair<uint32_t, uint32_t> > m_hwmpSeqnoMetricDatabase;
-  ///\}
+  ///@}
 
   /// Routing table
   Ptr<HwmpRtable> m_rtable;
@@ -447,24 +486,24 @@
   
   /// \name HWMP-protocol parameters
   /// These are all Attributes
-  /// \{
-  uint16_t m_maxQueueSize;
-  uint8_t m_dot11MeshHWMPmaxPREQretries;
-  Time m_dot11MeshHWMPnetDiameterTraversalTime;
-  Time m_dot11MeshHWMPpreqMinInterval;
-  Time m_dot11MeshHWMPperrMinInterval;
-  Time m_dot11MeshHWMPactiveRootTimeout;
-  Time m_dot11MeshHWMPactivePathTimeout;
-  Time m_dot11MeshHWMPpathToRootInterval;
-  Time m_dot11MeshHWMPrannInterval;
-  bool m_isRoot;
-  uint8_t m_maxTtl;
-  uint8_t m_unicastPerrThreshold;
-  uint8_t m_unicastPreqThreshold;
-  uint8_t m_unicastDataThreshold;
-  bool m_doFlag;
-  bool m_rfFlag;
-  ///\}
+  ///@{
+  uint16_t m_maxQueueSize;                        //!< Maximum number of packets we can store when resolving route
+  uint8_t m_dot11MeshHWMPmaxPREQretries;          //!< Maximum number of retries before we suppose the destination to be unreachable
+  Time m_dot11MeshHWMPnetDiameterTraversalTime;   //!< Time we suppose the packet to go from one edge of the network to another
+  Time m_dot11MeshHWMPpreqMinInterval;            //!< Minimal interval between to successive PREQs
+  Time m_dot11MeshHWMPperrMinInterval;            //!< Minimal interval between to successive PREQs
+  Time m_dot11MeshHWMPactiveRootTimeout;          //!< Lifetime of proactive routing information
+  Time m_dot11MeshHWMPactivePathTimeout;          //!< Lifetime of reactive routing information
+  Time m_dot11MeshHWMPpathToRootInterval;         //!< Interval between two successive proactive PREQs
+  Time m_dot11MeshHWMPrannInterval;               //!< Lifetime of proactive routing information
+  bool m_isRoot;                                  //!< True if the node is a root
+  uint8_t m_maxTtl;                               //!< Initial value of Time To Live field
+  uint8_t m_unicastPerrThreshold;                 //!< Maximum number of PERR receivers, when we send a PERR as a chain of unicasts
+  uint8_t m_unicastPreqThreshold;                 //!< Maximum number of PREQ receivers, when we send a PREQ as a chain of unicasts
+  uint8_t m_unicastDataThreshold;                 //!< Maximum number of broadcast receivers, when we send a broadcast as a chain of unicasts
+  bool m_doFlag;                                  //!< Destination only HWMP flag
+  bool m_rfFlag;                                  //!< Reply and forward flag
+  ///@}
   
   /// Random variable for random start time
   Ptr<UniformRandomVariable> m_coefficient; ///< coefficient
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/hwmp-protocol-mac.h ns-3.34/src/mesh/model/dot11s/hwmp-protocol-mac.h
--- ns-3.33/src/mesh/model/dot11s/hwmp-protocol-mac.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/hwmp-protocol-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -31,7 +31,6 @@
 
 namespace dot11s {
 
-class HwmpProtocol;
 class IePreq;
 class IePrep;
 class IePerr;
@@ -52,15 +51,14 @@
    */
   HwmpProtocolMac (uint32_t ifIndex, Ptr<HwmpProtocol> protocol);
   ~HwmpProtocolMac ();
-  ///\name Inherited from MAC plugin
-  //\{
+
+  // Inherited from MAC plugin
   void SetParent (Ptr<MeshWifiInterfaceMac> parent);
   bool Receive (Ptr<Packet> packet, const WifiMacHeader & header);
   bool UpdateOutcomingFrame (Ptr<Packet> packet, WifiMacHeader & header, Mac48Address from, Mac48Address to);
-  /// Update beacon is empty, because HWMP does not know anything about beacons
+  // Update beacon is empty, because HWMP does not know anything about beacons
   void UpdateBeacon (MeshWifiBeacon & beacon) const {};
   int64_t AssignStreams (int64_t stream);
-  //\}
 
 private:
   /// allow HwmpProtocol class friend access
@@ -69,8 +67,8 @@
    * \returns a path selection action header
    */
   static WifiActionHeader GetWifiActionHeader ();
-  ///\name Interaction with HWMP:
-  //\{
+  /// \name Interaction with HWMP:
+  ///@{
   /**
    * Send PREQ function
    * \param preq the PREQ
@@ -107,7 +105,7 @@
    * \param dst_seqno is a sequence number taken from routing table
    */
   void RequestDestination (Mac48Address dest, uint32_t originator_seqno, uint32_t dst_seqno);
-  //\}
+  ///@}
 
   /// Sends one PREQ when PreqMinInterval after last PREQ expires (if any PREQ exists in rhe queue)
   void SendMyPreq ();
@@ -135,13 +133,14 @@
   uint32_t m_ifIndex; ///< IF index
   Ptr<HwmpProtocol> m_protocol; ///< protocol
 
-  ///\name my PREQ and PREQ timer:
-  //\{
-  EventId m_preqTimer; 
-  std::vector<IePreq>  m_myPreq;
-  //\}
-  ///\name PERR timer and stored path error
-  //\{
+  /// \name my PREQ and PREQ timer:
+  ///@{
+  EventId m_preqTimer; //!< Timer for PREQs
+  std::vector<IePreq>  m_myPreq; //!< container of PREQs
+  ///@}
+
+  /// \name PERR timer and stored path error
+  ///@{
   EventId m_perrTimer;
   /// MyPerr structure
   struct MyPerr {
@@ -149,9 +148,14 @@
     std::vector<Mac48Address> receivers; ///< receivers
   };
   MyPerr m_myPerr; ///< PERR
-  ///\name Statistics:
-  //\{
-  /// Statistics structure
+  ///@}
+
+  /// \name Statistics
+  ///@{
+
+  /**
+   * Statistics structure
+   */
   struct Statistics
   {
     uint16_t txPreq; ///< transmit PREQ
@@ -175,8 +179,10 @@
     void Print (std::ostream & os) const;
     Statistics ();
   };
+
   Statistics m_stats; ///< statistics
-  //\}
+  ///@}
+
 private:
   /**
    * Receive data frame
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/hwmp-rtable.h ns-3.34/src/mesh/model/dot11s/hwmp-rtable.h
--- ns-3.33/src/mesh/model/dot11s/hwmp-rtable.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/hwmp-rtable.h	2021-07-14 10:31:07.000000000 -0700
@@ -86,42 +86,100 @@
   ~HwmpRtable ();
   void DoDispose ();
 
-  ///\name Add/delete paths
-  //\{
+  /// \name Add/delete paths
+  ///@{
+
+  /**
+   * Add a reactive path
+   * \param destination the destination address
+   * \param retransmitter the retransmitter address
+   * \param interface the interface
+   * \param metric  the metric
+   * \param lifetime  the lifetime
+   * \param seqnum  the sequence number
+   */
   void AddReactivePath (
-    Mac48Address destination,
-    Mac48Address retransmitter,
-    uint32_t interface,
-    uint32_t metric,
-    Time  lifetime,
-    uint32_t seqnum
-    );
+      Mac48Address destination,
+      Mac48Address retransmitter,
+      uint32_t interface,
+      uint32_t metric,
+      Time  lifetime,
+      uint32_t seqnum
+  );
+  /**
+   * Add a proactive path
+   * \param metric  the metric
+   * \param root the address of the root
+   * \param retransmitter the retransmitter address
+   * \param interface the interface
+   * \param lifetime  the lifetime
+   * \param seqnum  the sequence number
+   */
   void AddProactivePath (
-    uint32_t metric,
-    Mac48Address root,
-    Mac48Address retransmitter,
-    uint32_t interface,
-    Time  lifetime,
-    uint32_t seqnum
-    );
+      uint32_t metric,
+      Mac48Address root,
+      Mac48Address retransmitter,
+      uint32_t interface,
+      Time  lifetime,
+      uint32_t seqnum
+  );
+   /**
+    * Add a precursor
+   * \param destination the destination address
+    * \param precursorInterface the precursor interface
+    * \param precursorAddress the address of the precursor
+    * \param lifetime the lifetime
+    */
   void AddPrecursor (Mac48Address destination, uint32_t precursorInterface, Mac48Address precursorAddress, Time lifetime);
+
+  /**
+   * Get the precursors list
+   * \param destination the destination
+   * \return the precursors list
+   */
   PrecursorList GetPrecursors (Mac48Address destination);
+
+  /**
+   * Delete all the proactive paths
+   */
   void DeleteProactivePath ();
+  /**
+   * Delete all the proactive paths from a given root
+   * \param root the address of the root
+   */
   void DeleteProactivePath (Mac48Address root);
+  /**
+   * Delete the reactive paths toward a destination
+   * \param destination the destination
+   */
   void DeleteReactivePath (Mac48Address destination);
-  //\}
+  ///@}
 
-  ///\name Lookup
-  //\{
-  /// Lookup path to destination
+  /// \name Lookup
+  ///@{
+  /**
+   * Lookup path to destination
+   * \param destination the destination
+   * \return The lookup result
+   */
   LookupResult LookupReactive (Mac48Address destination);
-  /// Return all reactive paths, including expired
+  /**
+   * Return all reactive paths, including expired
+   * \param destination the destination
+   * \return The lookup result
+   */
   LookupResult LookupReactiveExpired (Mac48Address destination);
-  /// Find proactive path to tree root. Note that calling this method has side effect of deleting expired proactive path
+  /**
+   * Find proactive path to tree root. Note that calling this method has side effect of deleting expired proactive path
+   * \return The lookup result
+   */
   LookupResult LookupProactive ();
-  /// Return all proactive paths, including expired
+  /**
+   * Return all proactive paths, including expired
+   * \return The lookup result
+   */
   LookupResult LookupProactiveExpired ();
-  //\}
+  ///@}
 
   /**
    * When peer link with a given MAC-address fails - it returns list of unreachable destination addresses
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/ie-dot11s-id.cc ns-3.34/src/mesh/model/dot11s/ie-dot11s-id.cc
--- ns-3.33/src/mesh/model/dot11s/ie-dot11s-id.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/ie-dot11s-id.cc	2021-07-14 10:31:07.000000000 -0700
@@ -149,8 +149,6 @@
   return is;
 }
 
-ATTRIBUTE_HELPER_CPP (IeMeshId);
-
 
 } // namespace dot11s
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/ie-dot11s-id.h ns-3.34/src/mesh/model/dot11s/ie-dot11s-id.h
--- ns-3.33/src/mesh/model/dot11s/ie-dot11s-id.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/ie-dot11s-id.h	2021-07-14 10:31:07.000000000 -0700
@@ -27,6 +27,7 @@
 
 namespace ns3 {
 namespace dot11s {
+
 /**
  * \brief a IEEE 802.11 Mesh ID element (Section 8.4.2.101 of IEEE 802.11-2012)
  * \see attribute_IeMeshId
@@ -81,9 +82,15 @@
 
 };
 
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] meshId The IeMeshId object.
+ * \returns The reference to the output stream.
+ */
 std::ostream &operator << (std::ostream &os, const IeMeshId &meshId);
 
-ATTRIBUTE_HELPER_HEADER (IeMeshId);
   
 } // namespace dot11s
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/peer-link.h ns-3.34/src/mesh/model/dot11s/peer-link.h
--- ns-3.33/src/mesh/model/dot11s/peer-link.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/peer-link.h	2021-07-14 10:31:07.000000000 -0700
@@ -81,29 +81,73 @@
    * with address (Mac48Address) was opened (bool is true) or closed (bool is false) 
    */
   void  SetLinkStatusCallback (Callback<void, uint32_t, Mac48Address, bool> cb);
+  /// \name Peer link getters/setters
+  ///@{
   /**
-   * \name Peer link getters/setters
-   * \{
+   * Set the peer address
+   * \param macaddr the peer mac address
    */
   void SetPeerAddress (Mac48Address macaddr);
+  /**
+   * Set the peer mesh point address
+   * \param macaddr the peer mesh point address
+   */
   void SetPeerMeshPointAddress (Mac48Address macaddr);
+  /**
+   * Set the interface
+   * \param interface the interface
+   */
   void SetInterface (uint32_t interface);
+  /**
+   * Set the local link ID
+   * \param id the local link ID
+   */
   void SetLocalLinkId (uint16_t id);
+  /**
+   * Set the local association ID
+   * \param aid the local association ID
+   */
   void SetLocalAid (uint16_t aid);
+  /**
+   * Set the peer association ID
+   * \return The peer association ID
+   */
   uint16_t GetPeerAid () const;
+  /**
+   * Set the beacon timing element
+   * \param beaconTiming the beacon timing element
+   */
   void SetBeaconTimingElement (IeBeaconTiming beaconTiming);
+  /**
+   * Get the peer address
+   * \return The peer address
+   */
   Mac48Address GetPeerAddress () const;
+  /**
+   * Get the local association ID
+   * \return The local association ID
+   */
   uint16_t GetLocalAid () const;
+  /**
+   * Get the time of the last received beacon
+   * \return The time of the last received beacon
+   */
   Time GetLastBeacon () const;
+  /**
+   * Get the beacon interval
+   * \return The beacon interval
+   */
   Time GetBeaconInterval () const;
+  /**
+   * Get the beacon timing element
+   * \return The beacon timing element
+   */
   IeBeaconTiming GetBeaconTimingElement () const;
   //IePeerManagement GetPeerLinkDescriptorElement ()const;
-  //\}
+  ///@}
 
-  /**
-   * \name MLME
-   * \{
-   */
+  /// \name MLME
+  ///@{
   /**
    * MLME-CancelPeerLink.request
    * \param reason the reason for the request
@@ -123,7 +167,8 @@
   /// Reports about transmission success/failure
   void TransmissionSuccess ();
   void TransmissionFailure ();
-  //\}
+  ///@}
+
   /**
    * \brief Statistics
    * \param os the output stream
@@ -159,8 +204,8 @@
    * \attention In all this methods {local/peer}LinkID correspond to _peer_ station, as written in
    * received frame, e.g. I am peerLinkID and peer link is localLinkID .
    *
-   * \{
    */
+  ///@{
   /**
    * Close link
    *
@@ -218,7 +263,8 @@
     Mac48Address peerMp,
     PmpReasonCode reason
     );
-  //\}
+  ///@}
+
   /**
    * \returns True if link is established
    */
@@ -235,33 +281,49 @@
   void SetMacPlugin (Ptr<PeerManagementProtocolMac> plugin);
   /**
    * \name Event handlers
-   * \{
    */
+  ///@{
+  /// Clear the retry timer
   void ClearRetryTimer ();
+  /// Clear the confirm timer
   void ClearConfirmTimer ();
+  /// Clear the holding timer
   void ClearHoldingTimer ();
+  /// Set the holding timer
   void SetHoldingTimer ();
+  /// Set the retry timer
   void SetRetryTimer ();
+  /// Set the confirm timer
   void SetConfirmTimer ();
-  //\}
+  ///@}
 
   /**
    * \name Work with management frames
-   * \{
+   */
+  ///@{
+  /**
+   * Send a peer link close
+   * \param reasoncode reason for closing the line
    */
   void SendPeerLinkClose (PmpReasonCode reasoncode);
+  /// Send a peer link open
   void SendPeerLinkOpen ();
+  /// Send a peer link confirm
   void SendPeerLinkConfirm ();
-  //\}
+  ///@}
 
   /**
    * \name Timeout handlers
-   * \{
    */
+  ///@{
+  /// Holding Timeout event handler
   void HoldingTimeout ();
+  /// Retry Timeout event handler
   void RetryTimeout ();
+  /// Confirm Timeout event handler
   void ConfirmTimeout ();
-  //\}
+  ///@}
+
   /// Several successive beacons were lost, close link
   void BeaconLoss ();
 private:
@@ -273,10 +335,10 @@
    */
   PeerLink& operator= (const PeerLink & link);
   /**
-   * type conversion operator
-   * \returns the peer link
+   * Copy constructor. Intentionally unimplemented
+   * \param o object to copy
    */
-  PeerLink (const PeerLink &);
+  PeerLink (const PeerLink & o);
 
   /// The number of interface I am associated with
   uint32_t m_interface;
@@ -315,21 +377,22 @@
 
   /**
    * \name Timers & counters used for internal state transitions
-   * \{
    */
-  uint16_t m_dot11MeshMaxRetries;
-  Time     m_dot11MeshRetryTimeout;
-  Time     m_dot11MeshHoldingTimeout;
-  Time     m_dot11MeshConfirmTimeout;
-
-  EventId  m_retryTimer;
-  EventId  m_holdingTimer;
-  EventId  m_confirmTimer;
-  uint16_t m_retryCounter;
-  EventId  m_beaconLossTimer;
-  uint16_t m_maxBeaconLoss;
-  uint16_t m_maxPacketFail;
-  // \}
+  ///@{
+  uint16_t m_dot11MeshMaxRetries;     //!< Maximum number of retries
+  Time     m_dot11MeshRetryTimeout;   //!< Retry timeout
+  Time     m_dot11MeshHoldingTimeout; //!< Holding timeout
+  Time     m_dot11MeshConfirmTimeout; //!< Confirm timeout
+
+  EventId  m_retryTimer;            //!< Retry timer
+  EventId  m_holdingTimer;          //!< Holding timer
+  EventId  m_confirmTimer;          //!< Confirm timer
+  uint16_t m_retryCounter;          //!< Retry counter
+  EventId  m_beaconLossTimer;       //!< Beacon loss timer
+  uint16_t m_maxBeaconLoss;         //!< Maximum number of lost beacons before link will be closed
+  uint16_t m_maxPacketFail;         //!< Maximum number of failed packets before link will be closed
+  ///@}
+
   /// How to report my status change
   SignalStatusCallback m_linkStatusCallback;
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/peer-management-protocol.h ns-3.34/src/mesh/model/dot11s/peer-management-protocol.h
--- ns-3.33/src/mesh/model/dot11s/peer-management-protocol.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/peer-management-protocol.h	2021-07-14 10:31:07.000000000 -0700
@@ -59,6 +59,7 @@
   void DoDispose ();
   /**
    * \brief Install PMP on given mesh point.
+   * \param mp the MeshPointDevice to install onto
    * \return true if successful
    *
    * Installing protocol causes installation of its interface MAC plugins.
@@ -66,13 +67,13 @@
    * Also MP aggregates all installed protocols, PMP protocol can be accessed
    * via MeshPointDevice::GetObject<PeerManagementProtocol>();
    */
-  bool Install (Ptr<MeshPointDevice>);
+  bool Install (Ptr<MeshPointDevice> mp);
   /**
    * \brief Methods that handle beacon sending/receiving procedure.
    *
    * \name This methods interact with MAC_layer plug-in
-   * \{
    */
+  ///@{
   /**
    * \brief When we are sending a beacon - we fill beacon timing
    * element
@@ -88,19 +89,17 @@
    * \param beaconTiming beacon timing element (needed by BCA)
    */
   void ReceiveBeacon (uint32_t interface, Mac48Address peerAddress, Time beaconInterval, Ptr<IeBeaconTiming> beaconTiming);
-  // \}
+  ///@}
+
   /**
-   * \brief Methods that handle Peer link management frames
-   * interaction:
-   * \{
+   * \name Methods that handle Peer link management frames interaction:
    */
+  ///@{
   /**
    * Deliver Peer link management information to the protocol-part
-   * \param interface is a interface ID of a given MAC (interfaceID rather
-   * than MAC address, because many interfaces may have the same MAC)
+   * \param interface is a interface ID of a given MAC (interfaceID rather than MAC address, because many interfaces may have the same MAC)
    * \param peerAddress is address of peer
-   * \param peerMeshPointAddress is address of peer mesh point device (equal
-   * to peer address when only one interface)
+   * \param peerMeshPointAddress is address of peer mesh point device (equal to peer address when only one interface)
    * \param aid is association ID, which peer has assigned to us
    * \param peerManagementElement is peer link management element
    * \param meshConfig is mesh configuration element taken from the peer management frame
@@ -116,30 +115,55 @@
   /**
    * \brief Cancels peer link due to broken configuration (Mesh ID or Supported
    * rates)
+   * \param interface interface of the link to cancel
+   * \param peerAddress peer address of the link to cancel
    */
   void ConfigurationMismatch (uint32_t interface, Mac48Address peerAddress);
   /**
    * \brief Cancels peer link due to successive transmission failures
+   * \param interface interface of the link to cancel
+   * \param peerAddress peer address of the link to cancel
    */
   void TransmissionFailure (uint32_t interface, const Mac48Address peerAddress);
   /**
    * \brief resets transmission failure statistics
+   * \param interface interface of the link to reset
+   * \param peerAddress peer address of the link to reset
    */
   void TransmissionSuccess (uint32_t interface, const Mac48Address peerAddress);
   /**
    * \brief Checks if there is established link
+   * \param interface interface of the link to check
+   * \param peerAddress peer address of the link to check
+   * \return true if the link is active
    */
   bool IsActiveLink (uint32_t interface, Mac48Address peerAddress);
-  // \}
-  ///\name Interface to other protocols (MLME)
-  // \{
-  /// Set peer link status change callback
+  ///@}
+
+  /// \name Interface to other protocols (MLME)
+  ///@{
+  /**
+   *  Set peer link status change callback
+   *  \param cb the callback
+   */
   void SetPeerLinkStatusCallback (Callback<void, Mac48Address, Mac48Address, uint32_t, bool> cb);
-  /// Find active peer link by my interface and peer interface MAC
+  /**
+   * Find active peer link by my interface and peer interface MAC
+   * \param interface interface of the link to find
+   * \param peerAddress peer address of the link to find
+   * \return The peer link (null if not found)
+   */
   Ptr<PeerLink> FindPeerLink (uint32_t interface, Mac48Address peerAddress);
-  /// Get list of all active peer links
+  /**
+   * Get list of all active peer links
+   * \return a list of all the active peer links
+   */
   std::vector < Ptr<PeerLink> > GetPeerLinks () const;
-  /// Get list of active peers of my given interface
+  /**
+   * Get list of active peers of my given interface
+   * \param interface the interface
+   * \return a list of all the active peer links on an interface
+   */
   std::vector<Mac48Address> GetPeers (uint32_t interface) const;
   /**
    * Get mesh point address. \todo this used by plugins only. Now MAC plugins can ask MP address directly from main MAC
@@ -178,10 +202,10 @@
    * \param beaconInterval the beacon interval
    */
   void NotifyBeaconSent (uint32_t interface, Time beaconInterval);
-  // \}
+  ///@}
   
   /**
-   * \brief: Report statistics
+   * \brief Report statistics
    * \param os the output stream
    */
   void Report (std::ostream & os) const;
@@ -255,36 +279,67 @@
     Mac48Address peerMeshPointAddress
     );
   /**
-   * \name External peer-chooser
+   * \brief External peer-chooser
    * \param interface the interface to use
    * \param peerAddress the peer address
    * \returns true is should send an open
    */
   bool ShouldSendOpen (uint32_t interface, Mac48Address peerAddress);
   /**
-   * \name External peer-chooser
+   * \brief External peer-chooser
+   * \param interface the interface to use
+   * \param peerAddress the peer address
+   * \param reasonCode reason code
+   * \returns true is should send an open
    */
   bool ShouldAcceptOpen (uint32_t interface, Mac48Address peerAddress, PmpReasonCode & reasonCode);
   /**
    * \brief Indicates changes in peer links
+   * \param interface the interface
+   * \param peerAddress the peer address
+   * \param peerMeshPointAddres the peer mesh point address
+   * \param ostate old state
+   * \param nstate new state
    */
   void PeerLinkStatus (uint32_t interface, Mac48Address peerAddress, Mac48Address peerMeshPointAddres, PeerLink::PeerState ostate, PeerLink::PeerState nstate);
-  ///\brief BCA
+  /**
+   * \brief BCA
+   * \param interface interface
+   */
   void CheckBeaconCollisions (uint32_t interface);
-  /// Shift own beacon function
+  /**
+   * Shift own beacon function
+   * \param interface interface
+   */
   void ShiftOwnBeacon (uint32_t interface);
   /**
-   * \name Time<-->TU converters:
+   * \brief Time<-->TU converters:
+   * \param x TU
+   * \return Time
    */
   Time TuToTime (int x);
   /**
-   * \name Time<-->TU converters:
+   * \brief Time<-->TU converters:
+   * \param x Time
+   * \return TU
    */
   int TimeToTu (Time x);
 
-  /// Aux. method to register open links
+  /**
+   * Aux. method to register open links
+   * \param peerMp peer mesh point address
+   * \param peerIface peer address
+   * \param myIface my address
+   * \param interface interface
+   */
   void NotifyLinkOpen (Mac48Address peerMp, Mac48Address peerIface, Mac48Address myIface, uint32_t interface);
-  /// Aux. method to register closed links
+  /**
+   * Aux. method to register closed links
+   * \param peerMp peer mesh point address
+   * \param peerIface peer address
+   * \param myIface my address
+   * \param interface interface
+   */
   void NotifyLinkClose (Mac48Address peerMp, Mac48Address peerIface, Mac48Address myIface, uint32_t interface);
 private:
   PeerManagementProtocolMacMap m_plugins; ///< plugins
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/peer-management-protocol-mac.cc ns-3.34/src/mesh/model/dot11s/peer-management-protocol-mac.cc
--- ns-3.33/src/mesh/model/dot11s/peer-management-protocol-mac.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/peer-management-protocol-mac.cc	2021-07-14 10:31:07.000000000 -0700
@@ -49,18 +49,18 @@
 PeerManagementProtocolMac::SetParent (Ptr<MeshWifiInterfaceMac> parent)
 {
   m_parent = parent;
-  m_parent->TraceConnectWithoutContext ("TxErrHeader", MakeCallback (&PeerManagementProtocolMac::TxError, this));
-  m_parent->TraceConnectWithoutContext ("TxOkHeader",  MakeCallback (&PeerManagementProtocolMac::TxOk,    this));
+  m_parent->TraceConnectWithoutContext ("DroppedMpdu", MakeCallback (&PeerManagementProtocolMac::TxError, this));
+  m_parent->TraceConnectWithoutContext ("AckedMpdu",   MakeCallback (&PeerManagementProtocolMac::TxOk,    this));
 }
 void
-PeerManagementProtocolMac::TxError (WifiMacHeader const &hdr)
+PeerManagementProtocolMac::TxError (WifiMacDropReason reason, Ptr<const WifiMacQueueItem> mpdu)
 {
-  m_protocol->TransmissionFailure (m_ifIndex, hdr.GetAddr1 ());
+  m_protocol->TransmissionFailure (m_ifIndex, mpdu->GetHeader ().GetAddr1 ());
 }
 void
-PeerManagementProtocolMac::TxOk (WifiMacHeader const &hdr)
+PeerManagementProtocolMac::TxOk (Ptr <const WifiMacQueueItem> mpdu)
 {
-  m_protocol->TransmissionSuccess (m_ifIndex, hdr.GetAddr1 ());
+  m_protocol->TransmissionSuccess (m_ifIndex, mpdu->GetHeader ().GetAddr1 ());
 }
 bool
 PeerManagementProtocolMac::Receive (Ptr<Packet> const_packet, const WifiMacHeader & header)
